#ifndef XTF_MSVC_CONFIG
#define XTF_MSVC_CONFIG

#include <inttypes.h>
#if defined(_MSC_VER)

#include <iostream>
#include <thread>
#include <winsock2.h>
#include <ws2tcpip.h>
#include <windows.h>
#include <intrin.h>
#include <errhandlingapi.h>
#include <iphlpapi.h>
#include <cctype>
#include <time.h>
#include "win_ver.h"

extern "C" DWORD pthread_self();

extern "C" int gettimeofday(struct timeval* tv, void* tz);

extern "C" int clock_gettime(int clk_id, struct timespec* ts);

extern "C" int sched_yield();

extern "C" void usleep(int useconds);

extern "C" int strncasecmp(const char *s1, const char *s2, size_t n);

extern "C" int strcasecmp(const char *s1, const char *s2);
typedef SSIZE_T ssize_t;
typedef DWORD pthread_t;

#define localtime_r(t, ts) localtime_s(ts, t)

LONG applicationCrashHandler(EXCEPTION_POINTERS* pException);

#define getpid _getpid
#define CLOCK_REALTIME		0
/* Monotonic system-wide clock.  */
#define CLOCK_MONOTONIC		1
/* High-resolution timer from the CPU.  */

#else
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <ulimit.h>
#include <sched.h>

#include <unistd.h>
#include <netinet/if_ether.h>
#include <ifaddrs.h>
#include <net/if.h>
#include <netpacket/packet.h> // for: struct sockaddr_ll
#include <netinet/udp.h>
#include <linux/if_ether.h>

#endif  // defined _MSC_VER
#endif  // XTF_MSVC_CONFIG
